﻿// Piano by Charles Petzold, January 2010
using System;
using System.Windows;
using System.Windows.Controls;

namespace Piano
{
    public partial class MainPage : UserControl
    {
        const int SAMPLE_RATE = 22050;
        const int AUDIO_BUFFER_LENGTH = 100;
        const int NUMBER_OF_VOICES = 8;

        public MainPage()
        {
            InitializeComponent();

            PianoVoices pianoVoices = new PianoVoices(mediaElement, SAMPLE_RATE, AUDIO_BUFFER_LENGTH, NUMBER_OF_VOICES);
            bassKeyboard.PianoVoices = pianoVoices;
            trebleKeyboard.PianoVoices = pianoVoices;

            bassKeyboard.Build(36, 67);
            trebleKeyboard.Build(53, 84);
        }
    }
}
