﻿// VolumeControl by Charles Petzold, January 2010
using System;
using System.Windows;
using System.Windows.Controls;

namespace Petzold.MultiTouch
{
    public partial class VolumeControl : UserControl
    {
        public static readonly DependencyProperty VolumeProperty =
            DependencyProperty.Register("Volume",
                typeof(double),
                typeof(VolumeControl),
                new PropertyMetadata(0.0, OnVolumeChanged));

        public event DependencyPropertyChangedEventHandler VolumeChanged;

        public VolumeControl()
        {
            DataContext = this;
            InitializeComponent();
        }

        public double Volume
        {
            set { SetValue(VolumeProperty, value); }
            get { return (double)GetValue(VolumeProperty); }
        }

        void OnTouchDialValueChanged(object sender, RoutedPropertyChangedEventArgs<double> args)
        {
            Volume = 96 * (args.NewValue + 150) / 300;
        }

        static void OnVolumeChanged(DependencyObject obj, DependencyPropertyChangedEventArgs args)
        {
            (obj as VolumeControl).OnVolumeChanged(args);
        }

        protected virtual void OnVolumeChanged(DependencyPropertyChangedEventArgs args)
        {
            touchDial.Value = 300 * Volume / 96 - 150;

            if (VolumeChanged != null)
                VolumeChanged(this, args);
        }
    }
}
