﻿// Adder by Charles Petzold, January 2010

namespace Petzold.SoundSynthesis
{
    public class Adder : IIntSampleProvider
    {
        public IIntSampleProvider Input1 { get; set; }
        public IIntSampleProvider Input2 { get; set; }

        public int GetNextIntSample()
        {
            int sample = 0;

            if (Input1 != null)
                sample += Input1.GetNextIntSample();

            if (Input2 != null)
                sample += Input2.GetNextIntSample();

            return sample;
        }
    }
}
