﻿// PitchPipe by Charles Petzold, January 2010
using System;
using System.Windows;
using System.Windows.Controls;
using Petzold.SoundSynthesis;

namespace PitchPipe
{
    public partial class MainPage : UserControl
    {
        const int SAMPLE_RATE = 22050;
        const int AUDIO_BUFFER_LENGTH = 100;
        SawtoothOscillator sawtooth;

        public MainPage()
        {
            InitializeComponent();

            PcmMediaStreamSource mediaStreamSource = 
                new PcmMediaStreamSource(SAMPLE_RATE, 1, AUDIO_BUFFER_LENGTH);

            sawtooth = new SawtoothOscillator(SAMPLE_RATE);
            sawtooth.Frequency = pitchPipeControl.Frequency;
            sawtooth.Volume = volumeControl.Volume;

            mediaStreamSource.SampleProvider = sawtooth;
            mediaElement.SetSource(mediaStreamSource);
        }

        void OnVolumeChanged(object sender, DependencyPropertyChangedEventArgs args)
        {
            sawtooth.Volume = (double)args.NewValue;
        }

        void OnFrequencyChanged(object sender, DependencyPropertyChangedEventArgs args)
        {
            sawtooth.Frequency = (double)args.NewValue;
        }
    }
}
